/*
	$Id: InvalidUseOfNullException.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	This exception is thrown when an object field or a parameter
	that mustn't be null is set to null.

	@author Nicklas
	@version 2.0
*/
public class InvalidUseOfNullException
	extends InvalidDataException
{
	/**
		
	*/
	private static final long serialVersionUID = -5438951825783349420L;

	/**
		Create a new <code>InvalidUseOfNullException</code> object.
	*/
	public InvalidUseOfNullException()
	{
		super("Invalid use of null.");
	}

	/**
		Create a new <code>InvalidUseOfNullException</code> object.

		@param field The name of the field or parameter that cannot have a null value
	*/
	public InvalidUseOfNullException(String field)
	{
		super("Invalid use of null. The '"+field+"' value cannot be set to null.");
	}

}

