import net.sf.basedb.core.BaseException;
import net.sf.basedb.core.DbControl;
import net.sf.basedb.core.FileType;
import net.sf.basedb.core.ItemResultList;

/*
 $Id$

	Copyright (C) 2005 Johan Enell, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

 BASE is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3
 of the License, or (at your option) any later version.

 BASE is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with BASE. If not, see <http://www.gnu.org/licenses/>.
 */

public class TestFileType
{

	static boolean ok = true;
	public static void main(String[] args)
	{
		TestUtil.checkArgs(args);
		TestUtil.begin();
		ok = test_all();
		TestUtil.stop();
	}
	
	static boolean test_all()
	{
		write("++Testing file types");
		write_header();

		// Standard tests: list
		test_list();

		write("++Testing file types "+(ok ? "OK" : "Failed")+"\n");
		return ok;
	}

	static void test_list()
	{
		DbControl dc = null;
		try
		{
			dc = TestUtil.getDbControl();
			ItemResultList<FileType> l = FileType.getQuery().list(dc);
			int i = 0;
			for (FileType ft : l)
			{
				write_item(i++, ft);
			}
			write("--List file types OK ("+i+")");
		}
		catch (Throwable ex)
		{
			write("--List file types FAILED");
			ex.printStackTrace();
			ok = false;
		}
		finally
		{
			if (dc != null) dc.close();
		}
	}
	
	static void write_header()
	{
		if (!TestUtil.getSilent())
		{
			write("   \tID \tName\tDescription");
			write("-- \t-- \t----\t-----------");
		}
	}
	static void write_item(int i, FileType ft)
		throws BaseException
	{
		if (!TestUtil.getSilent())
		{
			System.out.println(i+":\t"+ft.getId()+"\t"+
				ft.getName()+"\t"+ft.getDescription()
				);
		}
	}
	static void write(String message)
	{
		System.out.println(message);
	}
}
