<%-- $Id: auto_install.jsp 5315 2010-04-19 05:46:06Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Martin
	@version 2.5
--%>
<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemNotFoundException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.util.FileUtil"
	import="net.sf.basedb.util.RegexpFileFilter"
	import="net.sf.basedb.util.JarClassLoader"
	import="net.sf.basedb.util.PluginInfo"
	import="net.sf.basedb.util.PluginConfigInfo"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.Tree"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Iterator"
	import="java.io.FileFilter"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!

private void addDirectory(DbControl dc, Tree<Object> tree, java.io.File directory)
	throws Exception
{
	FileFilter jarFilter = new RegexpFileFilter(".*\\.jar", null);
	List<java.io.File> jarFiles = FileUtil.findFiles(directory, jarFilter);
	for (java.io.File file : jarFiles)
	{
		addPluginJarFile(dc, tree, file);
	}
}

private void addPluginJarFile(DbControl dc, Tree<Object> tree, java.io.File file)
	throws Exception
{
	try
	{
		List<PluginInfo> plugins = PluginInfo.loadFromJar(file);
		if (plugins != null && plugins.size() > 0)
		{
			Tree.Entry<Object> jarEntry = tree.getRootEntry().addChild(file);
			for (PluginInfo pluginInfo : plugins)
			{
				pluginInfo.checkInstallation(dc);
				Tree.Entry<Object> pluginEntry = jarEntry.addChild(pluginInfo);
				List<PluginConfigInfo> configs = pluginInfo.getConfigurations();
				if (configs != null)
				{
					for (PluginConfigInfo configInfo : configs)
					{
						configInfo.checkInstallation(dc);
						pluginEntry.addChild(configInfo);
					}
				}
			}
		}
	}
	catch (Exception ex)
	{
		Tree.Entry<Object> jarEntry = tree.getRootEntry().addChild(file);
		jarEntry.addChild(ex);
	}
}
String generateJoustTree(Tree<Object> tree)
{
	StringBuilder sb = new StringBuilder();
	Tree.Entry<Object> rootEntry = tree.getRootEntry();
	Iterator<Tree.Entry<Object>> it = tree.entryIterator();
	while (it.hasNext())
	{
		Tree.Entry<Object> entry = it.next();
		Tree.Entry<Object> parentEntry = entry.getParent();
		Object node = entry.getNode();
		if (node == null) continue;
		int joustId = System.identityHashCode(entry);

		String name = node.toString();
		String folderIcon = "";
		boolean open = false;
		sb.append("var node").append(joustId).append(" = ");
		if (parentEntry == rootEntry)
		{
			sb.append("JoustMenu.addMenuItem(-1");
		}
		else
		{
			String parentVar = "node" + System.identityHashCode(parentEntry);
			sb.append("JoustMenu.addChildItem(").append(parentVar);
		}

		if (node instanceof java.io.File)
		{
			java.io.File file = (java.io.File)node;
			name = file.getName();
			folderIcon = "JarFile";
			Throwable error = null;
			int numUpdated = 0;
			int numInstalled = 0;
			for (Tree.Entry<Object> child : entry.getChildren())
			{
				if (child.getNode() instanceof PluginInfo)
				{
					PluginInfo info = (PluginInfo)child.getNode();
					if (!info.inSameJarFile() || info.hasDifferentVersion()) 
					{
						numUpdated++;
					}
					else
					{
						numInstalled++;
					}
				}
				else if (child.getNode() instanceof Throwable)
				{
					error = (Throwable)child.getNode();
				}
			}
			if (error != null)
			{
				name += " (" + error.getMessage() + ")";
				folderIcon = "JarFileError";
			}
			else if (numUpdated > 0)
			{
				name += " (" + numUpdated + " new";
				if (numInstalled > 0) name += "; " + numInstalled + " existing";
				name += ")";
				open = true;
			}
			else
			{
				name += " (already installed)";
			}
		}
		else if (node instanceof PluginInfo)
		{
			PluginInfo info = (PluginInfo)node;
			name = info.getAbout().getName();			
			if ( info.isDenied() || 
					(info.inSameJarFile() && !info.hasDifferentVersion()))
			{
				folderIcon = "PluginDisabled";
			}
			else if (info.isInstalled())
			{
				folderIcon = "PluginWarning";
			}
			else
			{
				folderIcon = "Plugin";
			}
		}
		else if (node instanceof PluginConfigInfo)
		{
			PluginConfigInfo info = (PluginConfigInfo)node;
			name = info.getName();
			if (info.exists())
			{
				folderIcon = "ConfigurationWarning";
			}
			else
			{
				folderIcon = "Configuration";
			}
		}
		else if (node instanceof Throwable)
		{
			Throwable t = (Throwable)node;
			name = t.toString();
			folderIcon = "Error";
		}
		
		sb.append(",'").append(folderIcon).append("'");
		sb.append(",'").append(HTML.javaScriptEncode(name)).append("'");
		sb.append(", null, '', '").append(joustId).append("');\n");
		if (open)
		{
			sb.append("JoustMenu.menuItems[node").append(joustId).append("].isOpen = true;\n");
		}
	}

	return sb.toString();
}

private String getInfoMessage(PluginInfo info, int id)
{
	StringBuilder message = new StringBuilder();
	message.append("<div id=\"info."+id+"\" class=\"postit\" style=\"width:500px; display:none;\">");
	
	if (!info.inSameJarFile())
	{
		message.append("<b>").append("Installed Jar: ").append("</b>");
		String oldjarpath = info.getJarPathInDatabase();
		message.append(oldjarpath).append("<br><b>New </b>");		
	}
	
	message.append("<b>").append("Jar: ").append("</b>");
	String jarpath = info.getJarPath();
	message.append(jarpath).append("<br>");
		
	message.append("<b>").append("Class: ").append("</b>");
	message.append(HTML.encodeTags(info.getClassName())).append("<br>");
	if (info.isInstalled() && info.hasDifferentVersion())
	{
		message.append("<b>").append("Version: ").append("</b>");
		message.append(HTML.encodeTags(info.getAbout().getVersion())).append("&nbsp;&nbsp;");
		
		message.append("(<i>").append("Installed version: ").append("</i>");
		message.append(HTML.encodeTags(info.getVersionInDatabase())).append(")<br>");
				
	}
	else
	{
		message.append("<b>").append("Version: ").append("</b>");
		message.append(HTML.encodeTags(info.getAbout().getVersion())).append("<br>");
	}
	
	message.append("<b>").append("Works with: ").append("</b>");
	message.append("BASE ").append(info.getMinBaseVersion()).append(" and higher").append("<br>");
	
	message.append("<b>").append("Description: ").append("</b>");
	message.append(HTML.encodeTags(info.getAbout().getDescription())).append("<br>");
	message.append("</div>");
	return message.toString();
}
%>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	String title = "Plugin autoinstaller";
	String tt = cc.getPropertyValue("trusted");
	String up = cc.getPropertyValue("usePermissions");
	String aie = cc.getPropertyValue("allowImmediateExection");
	boolean isTrusted = tt == null ? true : Values.getBoolean(tt);
	boolean usePermissions = up == null ? false : Values.getBoolean(up);
	Boolean allowImmediateExecution = aie == null ? null : Values.getBoolean(aie);
	boolean scanPluginDir = Values.getBoolean(request.getParameter("plugindir"));
	boolean scanExtensionsDir = Values.getBoolean(request.getParameter("extensionsdir"));
	
	java.io.File pluginDir = Application.getNonCorePluginDirectory();
	java.io.File extensionsDir = new java.io.File(application.getRealPath(ExtensionsControl.EXTENSIONS_URL));
	Tree<Object> plugins = new Tree<Object>(null);
	if (scanPluginDir) addDirectory(dc, plugins, pluginDir);
	if (scanExtensionsDir) addDirectory(dc, plugins, extensionsDir);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,newjoust.js" styles="tabcontrol.css">
		<script language="JavaScript">
		
		// Submit the form
		function saveSettings(install)
		{
			var frm = document.forms['autoinstall'];
			frm.submit();
		}
		function installAll(jarFile)
		{
			var frm = document.forms['autoinstall'];
			for (var i = 0; i < frm.elements.length; i++)
			{
				var element = frm[i];
				if (element.name.indexOf(jarFile) == 0 && element.type == 'select-one' && !element.disabled)
				{
					element.selectedIndex = element.options.length-1;
					pluginOnChange(element);
				}
			}
		}

		function pluginOnChange(list)
		{
			var selected = list[list.selectedIndex].value;
			var configOption = selected == 'plugin+confs' ? 1 : 0;
			var frm = document.forms['autoinstall'];
			var pluginClass = list.name.substring(list.name.indexOf(':')+1);
			for (var i = 0; i < frm.elements.length; i++)
			{
				var element = frm[i];
				if (element.name.indexOf(pluginClass+":config") == 0 && element.type == 'select-one' && !element.disabled)
				{
					Forms.selectListOption(element, configOption);
				}
			}		
		}

		function configOnChange(list)
		{
			var selected = list[list.selectedIndex].value;
			if (selected == 0) return;
			var frm = document.forms['autoinstall'];
			var pluginClass = list.name.substring(0, list.name.indexOf(':'));
			for (var i = 0; i < frm.elements.length; i++)
			{
				var element = frm[i];
				if (element.name.indexOf(pluginClass) > 0 && element.type == 'select-one' && !element.disabled)
				{
					Forms.selectListOption(element, 'plugin+confs');
				}
			}		
			
		}

		function toggleInformation(pluginId)
		{
			var infodiv = document.getElementById('info.'+pluginId);
			if (infodiv.style.display == 'block')
			{
				infodiv.style.display = 'none';				
			}
			else if (infodiv.style.display == 'none')
			{
				infodiv.style.display = 'block';
			}
		}
		function init()
		{
			var iconDir = getRoot()+'images/joust/';
			IconStore.init(iconDir + 'big/', 18, 22);
			IconStore.addIcon('JarFile', iconDir + 'jarfile.png', 18, 16);
			IconStore.addIcon('JarFileError', iconDir + 'jarfileerror.png', 18, 16);
			IconStore.addIcon('Plugin', iconDir + 'plugin.png', 18, 16);
			IconStore.addIcon('PluginDisabled', iconDir + 'plugindisabled.png', 18, 16);
			IconStore.addIcon('PluginWarning', iconDir + 'pluginwarning.png', 18, 16);
			IconStore.addIcon('Configuration', iconDir + 'item.gif', 18, 16);
			IconStore.addIcon('ConfigurationWarning', iconDir + 'itemwarning.gif', 18, 16);

			JoustMenu.toggle = function(menuItemIndex)
			{
				var menuItem = this.menuItems[menuItemIndex];
				if (!menuItem) return;
				// Switch the open/closed status and hide or show the children
				menuItem.isOpen = !menuItem.isOpen;
				if (menuItem.isOpen)
				{
					this.showChildren(menuItemIndex);
				}
				else
				{
					this.hideChildren(menuItemIndex);
				}
				this.updateIconsAndText(menuItemIndex);
			}
			
			JoustMenu.drawMenuItems = function(firstIndex, indentString)
			{
				var menuItem = this.menuItems[firstIndex];
				while (menuItem)
				{
					var html = menuItem.draw(indentString);
					var padIcon = IconStore.getIcon(menuItem.noOutlineIcon == true ? null : menuItem.nextItemIndex == -1 ? 'iconBlank' : 'iconLine');
					var padHtml = padIcon == null ? '' : padIcon.getImgTag();
					
					var menuDiv = document.getElementById('tree.'+menuItem.externalId);
					menuDiv.innerHTML = html;
					
					if (menuItem.firstChildIndex != -1)
					{
						this.drawMenuItems(menuItem.firstChildIndex, indentString+padHtml);
					}
					if (!menuItem.isOpen)
					{
						this.hideChildren(menuItem.index);
					}
					menuItem = this.menuItems[menuItem.nextItemIndex];
				}
				return '';
			}

			JoustMenu.hideChildren = function(menuItemIndex)
			{
				var menuItem = this.menuItems[menuItemIndex];
				if (menuItem)
				{
					var firstChildIndex = menuItem.firstChildIndex;
					var child = this.menuItems[firstChildIndex];
					while (child)
					{
						var e = document.getElementById('row.'+child.externalId);
						e.style.display = 'none';
						this.hideChildren(child.index);
						child = this.menuItems[child.nextItemIndex];
					}
				}
			}
			
			JoustMenu.showChildren = function(menuItemIndex)
			{
				var menuItem = this.menuItems[menuItemIndex];
				if (menuItem)
				{
					var firstChildIndex = menuItem.firstChildIndex;
					var child = this.menuItems[firstChildIndex];
					while (child)
					{
						var e = document.getElementById('row.'+child.externalId);
						e.style.display = Browser.isIE ? 'block' : 'table-row';
						if (child.isOpen)
						{
							this.showChildren(child.index);
						}
						child = this.menuItems[child.nextItemIndex];
					}
				}
			}
			<%=generateJoustTree(plugins)%>
			JoustMenu.draw('joust');
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<form name="autoinstall" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="LoadPlugins">
		<input type="hidden" name="plugindir" value="<%=scanPluginDir ? "1" : "0"%>">
		<input type="hidden" name="extensionsdir" value="<%=scanExtensionsDir ? "1" : "0"%>">
		
		<h3 class="docked"><%=title%> <base:help tabcontrol="plugins" /></h3>
		<t:tabcontrol id="plugins" contentstyle="<%="height: "+(int)(scale*340)+"px;"%>" 
			position="bottom">
			<t:tab id="plugins" title="Available plugins" validate="validatePlugins()" helpid="plugindefinition.autoinstaller">
				<div align="left">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
							<td width="45%"><b>Plugins</b></td>							
							<td><b>Install</b></td>
							<td><b>Trusted</b></td>
							<td><b>Immediate execution</b></td>
						</tr>
						<%
						Iterator<Tree.Entry<Object>> ite = plugins.entryIterator();
						while (ite.hasNext())
						{
							Tree.Entry<Object> entry = ite.next();
							Object node = entry.getNode();
							if (node == null) continue;
							int joustId = System.identityHashCode(entry);
							String name = node.toString();
							PluginInfo pluginInfo = null;
							PluginConfigInfo configInfo = null;
							java.io.File jarFile = null;
							Throwable error = null;
							if (node instanceof PluginInfo)
							{
								pluginInfo = (PluginInfo)node;
								name = pluginInfo.getAbout().getName();
							}
							else if (node instanceof PluginConfigInfo)
							{
								configInfo = (PluginConfigInfo)node;
								name = configInfo.getName();
							}
							else if (node instanceof java.io.File)
							{
								jarFile = (java.io.File)node;
								name = jarFile.getName();
							}
							else if (node instanceof Throwable)
							{
								error = (Throwable)node;
							}
							%>
							<tr id="row.<%=joustId%>">
								<td style="white-space: nowrap;"><div id="tree.<%=joustId%>"><%=name %></div></td>
								<%
								if (jarFile != null)
								{
									boolean enableInstall = false;
									for (Tree.Entry<Object> child : entry.getChildren())
									{
										if (child.getNode() instanceof PluginInfo)
										{
											PluginInfo info = (PluginInfo)child.getNode();
											if (!info.isInstalled() || 
													!info.inSameJarFile() || 
													info.hasDifferentVersion()) 
											{
												enableInstall = true; 
											}
										}
									}
									if (enableInstall)
									{
										%>
										<td><a href="javascript:installAll('<%=jarFile.getAbsolutePath()%>')">Install all</a></td>
										<% 
									}
								}
								if (pluginInfo != null)
								{
									boolean disabled = pluginInfo.isDenied() || 
										(pluginInfo.inSameJarFile() && !pluginInfo.hasDifferentVersion());
									%>
									<td>
										<input type="hidden" name="<%=pluginInfo.getClassName()%>:isInstalled" value="<%=pluginInfo.isInstalled()%>">
										<input type="hidden" name="<%=pluginInfo.getClassName()%>:inSameJarFile" value="<%=pluginInfo.inSameJarFile()%>">
										<input type="hidden" name="<%=pluginInfo.getClassName()%>:hasDifferentVersion" value="<%=pluginInfo.hasDifferentVersion()%>">
										<select  
											name="<%=pluginInfo.getJarPath()%>:<%=pluginInfo.getClassName()%>"
											onchange="pluginOnChange(this)"
											style="width:90px"
										 	<%=disabled ? "disabled" : "" %>
											>
											<%
											if (disabled)
											{
												%>
												<option value="" title="Already installed">installed
												<%
											}
											else
											{
												%>
												<option value="" title="Plugin will not be <%=pluginInfo.isInstalled() ? "updated" : "installed"%>" >no
												<%
											}
											if (pluginInfo.hasConfigurations())
											{
												String titleText = pluginInfo.isInstalled() ? "Plugin will be updated and all configurations will be installed" : 
													"Plugin and all configurations will be installed";
												%>
												<option 
													value="plugin" 
													title="Only the plugin will be <%=pluginInfo.isInstalled() ? "updated" : "installed"%>" >plugin only
												<option 
													value="plugin+confs" 
													title="<%=titleText%>" >plugin + configurations</option>
												<%
											}
											else
											{
												%>
												<option value="plugin" title="Plugin will be <%=pluginInfo.isInstalled() ? "updated" : "installed"%>">yes
												<%
											}
											%>
										</select>
										<a onmouseover="javascript:toggleInformation(<%=joustId%>)" 
											onmouseout="javascript:toggleInformation(<%=joustId%>)"
											><base:icon image="info.gif"/></a>
											<%=getInfoMessage(pluginInfo, joustId) %>
									</td>
									<%
									if (!disabled)
									{
										%>
										<td>
											<select name="<%=pluginInfo.getClassName()%>:trusted" 
												<%=disabled ? "disabled" : ""%>
											>
												<option value="0">no
												<option value="1">yes
											</select>
										</td>
									<td>
										<select name="<%=pluginInfo.getClassName()%>:immediate_execution" 
											<%=disabled ? "disabled" : ""%>
											>
											<option value="0">deny
											<option value="1">allow
											<%
											if (allowImmediateExecution == null)
											{
												%>
												<option value="" selected>auto
												<%
											}
											%>
										</select>
									</td>
									<%
								}
							}
							else if (configInfo != null)
							{
								%>
								<td>
									<select 
										onchange="configOnChange(this)"
										name="<%=configInfo.getPluginClass()%>:config:<%=configInfo.getName()%>">
										<option value="0" title="Configuration will not be imported">no</option>
										<option value="1" title="Configuration will be imported">yes</option>
									</select>
								</td>
								<%
							}
							%>
							</tr>
							<%
						}
						%>
					</table>					
				</div>
				<div align="right">
					&nbsp;<i><base:icon image="joust/plugindisabled.png" /> = plug-in is already installed</i><br>
					&nbsp;<i><base:icon image="joust/pluginwarning.png" /> = another version is installed</i><br>
					&nbsp;<i><base:icon image="joust/itemwarning.gif" /> = configuration already exists</i><br>
				</div>
			</t:tab>
		</t:tabcontrol>
		
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>	
	</base:page>
	<%	
}
finally
{
	if (dc != null) dc.close();
}
%>