<%-- $Id: submit_preset.jsp 5111 2009-09-30 10:56:51Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Configure the order and visibility of columns in a table of items.
	This page will use the TableColumn.getTableColumns(item) to retreive the
	list of all available columns for that item type and
	getSession().getSetting(item+".columns") to retreive a comma-separated
	list of the current order of visible columns.

	@param item The type of items in the table
	@param cmd
	  - Save: To save the settings
	  - otherwise: A configuration dialouge is displayed
	@param columns Only used if cmd=Save. Contains a comma-separated list
		of column ID:s which is saved to a user-client setting.

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final String cmd = request.getParameter("cmd");
final String name = request.getParameter("name");
final String settingName = Values.getString(request.getParameter("settingName"), "columns");
final ItemContext cc = sc.getCurrentContext(itemType, subContext);

String onload = null;
if ("Save".equals(cmd))
{
	String columns = request.getParameter("columns");
	cc.setSetting(settingName, columns);
	sc.saveCurrentContextAs(itemType, subContext, name, true, false);
	onload = "addPreset('"+HTML.encodeTags(name)+"', '"+HTML.encodeTags(columns)+"')";
}
%>
<head>
<script language="JavaScript">
function addPreset(name, columns)
{
	var presets = window.opener.document.forms['columns'].presets;
	var newIndex = presets.length;
	for (var i = 0; i < presets.length; i++) // >
	{
		if (presets[i].text == name) 
		{
			newIndex = i;
			i = presets.length;
		}
	}
	window.opener.Forms.replaceListOption(presets, newIndex, new Option(name, columns));
	presets.selectedIndex = newIndex;
	window.close();
}
</script>
</head>
<body onload="<%=onload%>">
</body>
