<%-- $Id: ajax.jsp 5145 2009-10-20 06:50:49Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.Node"
	import="net.sf.basedb.util.overview.OverviewUtil"	
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String nodeId = request.getParameter("node_id");
DbControl dc = null;
out.clear();
try
{
	if ("GetSubNodes".equals(cmd))
	{
		dc = sc.newDbControl();
		GenericOverview overview = OverviewUtil.getCurrentOverview(sc);
		Node parent = overview.getNode(nodeId);
		overview.expand(dc, parent, false);
		overview.updateFailureCountOnNodes();
		if (parent != null && parent.numChildren() > 0)
		{
			for (Node n : parent.getChildren())
			{
				String folderIcon = n.getNodeType() == Node.Type.FOLDER ? "Folder" : "Item";
				if (n.getItemType() == Item.ANNOTATIONTYPE)
				{
					if (parent.getItemType() == Item.PROTOCOL)
					{
						folderIcon = "ProtocolParameter";
					}
					else
					{
						try
						{
							AnnotationType at = (AnnotationType)n.getItem(dc);
							if (at.isProtocolParameter()) folderIcon = "ProtocolParameter";
						}
						catch (Throwable t)
						{}
					}
				}
				else if (n.getItemType() == Item.ANNOTATION)
				{
					folderIcon = "Annotation";
					try
					{
						AnnotationType at = ((Annotation)n.getItem(dc)).getAnnotationType();
						if (at.isProtocolParameter()) folderIcon = "ProtocolParameter";
					}
					catch (Throwable t)
					{}
				}				
				int numChildren = n.numChildren();
				%>begin
id	<%=n.getId()%>
title	<%=n.getTitle() + (n.getNodeType() == Node.Type.FOLDER ? " (" + numChildren + ")" : "")%>
folderIcon	<%=folderIcon %>
numChildren	<%=numChildren %>
end
<%
			}
			dc.commit();
		}
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}
//out.flush();
//out.close();
%>