<%-- $Id: permission_denied.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is used to catch PermissionDeniedExceptions which are
	directed here via the exception.jsp page. PermissionDeniedExceptions
	happen when a user tries to access a protected page without the proper
	permission. Typically the exception is thrown from the method that
	retrieves the BaseControl object:

	BASE.getExistingBaseControl(pageContext, permission, item_type);

	The exception is also thrown if trying to manipulate an item without
	the proper permission, but normally such conditions should not happen
	if the interface behaves corretly (ie. no "Edit item" link is displayed
	unless the user has the permission).

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	isErrorPage="true"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld"
%>
<%
Throwable t = exception;
//t is either a JasperException, a ServletException or a WebException; see exception.jsp
if (t instanceof org.apache.jasper.JasperException)
{
	t = ((org.apache.jasper.JasperException)t).getRootCause();
}
if (t instanceof ServletException)
{
	t = ((ServletException)t).getRootCause();
	// t should now be an PermissionDeniedException
}
Throwable ex = t;
%>
<base:page type="default" menu="exception" title="Permission denied">
<base:head>
	<script language="JavaScript">
	function fixWindow()
	{
		if (history.length <= 1) // >
		{
			Main.hide('goback');
		}
		if (window.opener != null)
		{
			// popup window --> Hide menubar
			Main.hide('menubar');
			var width = Main.getWindowWidth();
			var height = Main.getWindowHeight();
			if (height < 400) height = 400;
			if (width < 600) width = 600; // >
			window.resizeTo(width, height);
		}
		else
		{
			// Hide close button
			Main.hide('close');
			// If inside a second frameset, hide menubar
			if (window.parent != window.top)
			{
				Main.hide('menubar');
			}
		}
	}
	</script>
</base:head>
<base:body onload="fixWindow()">

	<div align="center">
		<base:note type="error" title="<%="On page "+request.getAttribute("javax.servlet.error.request_uri")%>" style="width:90%;">
		<%=ex.getMessage()%>
		</base:note>
	</div>

	<table align="center">
	<tr>
		<td id="goback" width="50%"><base:button onclick="history.go(-1);" title="Back" /></td>
		<td id="close" width="50%"><base:button onclick="window.close();" title="Close" /></td>
	</tr>
	</table>

</base:body>
</base:page>

