<%-- $Id: edit_platetype.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATETYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PlateType plateType = null;
	ItemResultList<PlateGeometry> plateGeometries = null;
	boolean readCurrentGeometry = true;
	PlateGeometry currentGeometry = null;
	int currentGeometryId = 0;

	if (itemId == 0)
	{
		title = "Create plate type";
		cc.removeObject("item");
		
		ItemQuery<PlateGeometry> geometryQuery = PlateGeometry.getQuery();
		geometryQuery.include(Include.ALL);
		geometryQuery.order(Orders.asc(Hql.property("name")));
		geometryQuery.setCacheResult(true);
		plateGeometries = geometryQuery.list(dc);
		currentGeometryId = Values.getInt(request.getParameter("plategeometry_id"));
		if (currentGeometryId == 0)
		{
			int recentGeometry = Values.getInt(cc.getRecent(Item.PLATEGEOMETRY.name(), 0), 0);
			currentGeometryId = Values.getInt(cc.getPropertyValue("plateGeometry"), recentGeometry);
		}
	}
	else
	{
		plateType = PlateType.getById(dc, itemId);
		cc.setObject("item", plateType);
		title = "Edit plate type -- " + HTML.encodeTags(plateType.getName());
		try
		{
			currentGeometry = plateType.getPlateGeometry();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentGeometry = false;
		}
	}
	if (plateType != null && !plateType.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "PlateType" tab
		function validatePlateType()
		{
			var frm = document.forms['platetype'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['platetype'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			var frm = document.forms['platetype'];
			<%
			if (plateType == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="platetype" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*160)+"px;"%>" 
			position="bottom" remember="<%=plateType != null%>">
		<t:tab id="info" title="Plate type" validate="validatePlateType()" helpid="platetype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(plateType == null ? Values.getString(cc.getPropertyValue("name"), "New plate type") : plateType.getName())%>" 
					size="40" maxlength="<%=PlateType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Geometry</td>
				<td>
					<%
					if (plateType == null)
					{
						%>
						<select name="plategeometry_id" class="required">
						<%
						for (PlateGeometry pg : plateGeometries)
						{
							if (pg.isRemoved() && pg.getId() != currentGeometryId) continue;
							%>
							<option value="<%=pg.getId()%>" <%=pg.getId() == currentGeometryId ? "selected" : ""%>><%=HTML.encodeTags(pg.getName())%>
							<%
						}
						%>
						</select>
						can't be changed later
						<%
					}
					else
					{
						%>
						<%=Base.getEncodedName(currentGeometry, !readCurrentGeometry)%>
						<%
					}
					%>
				</td>
			</tr>



			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(plateType == null ? cc.getPropertyValue("description") : plateType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'platetype', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
