<%-- $Id: external_plugin_parameters.jsp 5303 2010-04-12 07:19:32Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2010 Martin Svensson
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.15
--%>
<%@ page session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ParameterType"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.PluginParameter"	
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.plugins.executor.ExternalProgramExecutor"
	import="net.sf.basedb.plugins.executor.ParameterDefinition"
	import="net.sf.basedb.util.Values"	
	import="java.util.ArrayList"
	import="java.util.Arrays"
	import="java.util.Collections"
	import="java.util.HashMap"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"	
	import="org.jdom.Element"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String clazz = "class=\"text\"";
final String requiredClazz = "class=\"text required\"";

DbControl dc = null;
try
{
	PluginDefinition plugin = (PluginDefinition)sc.getSessionSetting("plugin.configure.plugin");	
	PluginConfiguration pluginConfig = (PluginConfiguration)sc.getSessionSetting("plugin.configure.config");
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	RequestInformation ri = pcRequest.getRequestInformation();
	String title = HTML.encodeTags(ri.getTitle());
	String helpText = ri.getDescription();	
	if (helpText == null && config != null) helpText = pluginConfig.getDescription();
	if (helpText == null) helpText = plugin.getDescription();

	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	String xml = request.getParameter("parameter:externalParameters");
	if (xml == null) xml = (String)pcRequest.getCurrentParameterValue("externalParameters");
	List<ParameterDefinition> externalParameters = null;
	try
	{
		externalParameters = ParameterDefinition.parseXml(xml, false);
	}
	catch (Throwable ex)
	{
		errorMessage = "Could not load parameter definitions";
		errors = Collections.singletonList(ex);
	}
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="plugin.js,xml.js" styles="parameters.css,toolbar.css">
		<script language="JavaScript">
			function init()
			{
				var frm = document.forms['configure'];
				var pd;
				<%
				if (externalParameters != null)
				{
					for (ParameterDefinition pdef : externalParameters)
					{
						%>
						pd = new ParameterDefinition('<%=pdef.getType()%>', '<%=HTML.javaScriptEncode(pdef.getName())%>', <%=pdef.isRequired() ? 1 : 0%>);
						pd.multiple = <%=pdef.isMultiple() ? "1" : "0"%>;
						pd.defaultValue = '<%=HTML.javaScriptEncode(pdef.getDefaultValue())%>';
						pd.description = '<%=HTML.javaScriptEncode(pdef.getDescription())%>';
						<%
						for (String option : pdef.getOptions())
						{
							%>
							pd.setOption('<%=option%>', '<%=HTML.javaScriptEncode(pdef.getOption(option))%>');
							<%
						}
						%>
						allParameters[allParameters.length] = pd;
						pd.addToList(frm.programParameters);
						<%
					}
				}
				%>
			}

			function hideErrorList()
			{
				Main.hide('errorlist');
				Main.show('showerrorlist');
			}
			function showErrorList()
			{
				Main.show('errorlist');
				Main.hide('showerrorlist');
			}
			function toggleStacktrace(index)
			{
				Main.showHide('stacktrace.' + index);
				var img = document.getElementById('stacktracelink.'+index);
				if (img.src.indexOf('show_section') > 0)
				{
					img.src = getRoot() + '/images/hide_section.gif';
				}
				else
				{
					img.src = getRoot() + '/images/show_section.gif';
				}
			}

			function doCancel()
			{
				location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
			}

			function saveSettings()
			{
				var frm = document.forms['configure'];
				var xml = '<parameter-definition>\n';
				for (var i=0; i < allParameters.length; i++)
				{
					var pdef = allParameters[i];
					var error = pdef.validate(frm);
					if (error)
					{
						frm.programParameters.selectedIndex = i;
						parameterOnClick();
						if (error.field.focus) error.field.focus();
						alert(error.msg);
						return;
					}
					xml += pdef.toXml() + '\n';
				}
				xml += '</parameter-definition>\n';
				frm['parameter:externalParameters'].value = xml;
				frm.submit();
			}

			function setRadio(name, index)
			{
				var frm = document.forms['configure'];
				frm[name][index].click();
			}

			function parameterTypeOnChange()
			{
				updateForm();
				onFormChange();
			}
			
			function onFormChange()
			{
				var frm = document.forms['configure'];
				var parameterDef = allParameters[currentParameter];
				parameterDef.readFromForm(frm);
				parameterDef.updateListOption(frm.programParameters[currentParameter]);
			}

			function addOnClick()
			{
				var frm = document.forms['configure'];
				var pdef = new ParameterDefinition('string', 'new', 0);
				allParameters[allParameters.length] = pdef;
				pdef.addToList(frm.programParameters);
				frm.programParameters.selectedIndex = frm.programParameters.length-1;
				parameterOnClick();
				frm.parameterName.focus();
				frm.parameterName.select();
			}


			function removeOnClick()
			{
				var frm = document.forms['configure'];
				var selected = frm.programParameters.selectedIndex;
				if (!confirm('Remove ' + allParameters[selected].name + '?')) return;
				frm.programParameters[selected] = null;
				allParameters.splice(selected, 1);
				Main.hide('parameterDefinition');
			}
			
			function moveParameter(up)
			{
				var frm = document.forms['configure'];
				var selected = frm.programParameters.selectedIndex;
				Forms.moveListOptions(frm.programParameters, up);
				var moveTo = -1;
				if (up)
				{
					if (selected < allParameters.length - 1) moveTo = selected + 1;
				}
				else 
				{
					if (selected > 0) moveTo = selected - 1;
				}
				if (moveTo >= 0)
				{
					var pp = allParameters[selected];
					allParameters[selected] = allParameters[moveTo];
					allParameters[moveTo] = pp;
				}
			}

			var currentParameter;
			function parameterOnClick()
			{
				var frm = document.forms['configure'];
				if (frm.programParameters.selectedIndex < 0) return;
				currentParameter = frm.programParameters.selectedIndex;
				var parameterDef = allParameters[currentParameter];
				if (!parameterDef) return;
				Main.show('parameterDefinition');
				parameterDef.writeToForm(frm);
				updateForm();
			}

			function updateForm()
			{
				var frm = document.forms['configure'];
				var type = frm.parameterType[frm.parameterType.selectedIndex].value;
				if (type == 'integer')
				{
					frm.parameterDefault.setAttribute("onkeypress", "return Numbers.integerOnly(event)");
					frm.minValue.setAttribute("onkeypress", "return Numbers.integerOnly(event)");
					frm.maxValue.setAttribute("onkeypress", "return Numbers.integerOnly(event)");
					Main.show('minMax');
				}
				else if (type == 'float')
				{
					frm.parameterDefault.setAttribute("onkeypress", "return Numbers.numberOnly(event)");
					frm.minValue.setAttribute("onkeypress", "return Numbers.numberOnly(event)");
					frm.maxValue.setAttribute("onkeypress", "return Numbers.numberOnly(event)");
					Main.show('minMax');
				}
				else
				{
					frm.parameterDefault.setAttribute("onkeypress", null);
					Main.hide('minMax');
				}
				if (type == 'boolean')
				{
					Main.show('booleanDefault');
					Main.hide('regularDefault');
				}
				else
				{
					Main.hide('booleanDefault');
					Main.show('regularDefault');
				}
				if (type == 'enumeration')
				{
					Main.show('enumerationOptions');
				}
				else
				{
					Main.hide('enumerationOptions');
				}
				
			}

			
			var allParameters = new Array();
			function ParameterDefinition(parameterType, name, required)
			{
				this.parameterType = parameterType;
				this.name = name;
				this.required = required;
				this.multiple = 0;
				this.defaultValue = '';
				this.description = '';
				this.options = new Array();

				this.setOption = function(key, value)
				{
					this.options[key] = value;
				}

				this.getOption = function(key)
				{
					return this.options[key];
				}
				
				this.writeToForm = function(frm)
				{
					Forms.selectListOption(frm.parameterType, this.parameterType);
					frm.parameterName.value = this.name;
					frm.parameterIsRequired.checked = this.required;
					frm.parameterIsMultiple.checked = this.multiple;
					if (this.parameterType == 'boolean')
					{
						Forms.checkRadio(frm.booleanDefault, this.defaultValue);
					}
					else
					{
						frm.parameterDefault.value = this.defaultValue;
					}
					frm.enumerationOptions.value = this.options['enum'] || '';
					frm.minValue.value = this.options['min'] || '';
					frm.maxValue.value = this.options['max'] || '';
					frm.parameterDescription.value = this.description;
					if (frm.parameterXML) frm.parameterXML.value = this.toXml();
				}

				this.readFromForm = function(frm)
				{
					this.parameterType = frm.parameterType[frm.parameterType.selectedIndex].value;
					this.name = frm.parameterName.value;
					this.required = frm.parameterIsRequired.checked ? 1 : 0;
					this.multiple = frm.parameterIsMultiple.checked ? 1 : 0;
					if (this.parameterType == 'boolean')
					{
						var radio = Forms.getCheckedRadio(frm.booleanDefault);
						this.defaultValue = radio ? radio.value : '';
					}
					else
					{
						this.defaultValue = frm.parameterDefault.value;
					}
					if (this.parameterType == 'enumeration')
					{
						this.setOption('enum', frm.enumerationOptions.value);
					}
					if (this.parameterType == 'integer' || this.parameterType == 'float')
					{
						this.setOption('min', frm.minValue.value);
						this.setOption('max', frm.maxValue.value);
					}
					this.description = frm.parameterDescription.value;
				}

				this.updateListOption = function(listOption)
				{
					listOption.value = this.name;
					listOption.text = this.toString();
				}
				
				this.addToList = function(list)
				{
					Forms.addListOption(list, -1, new Option(this.toString(), this.name));
				}
				
				this.toString = function()
				{
					return this.name + ' (' + this.parameterType + ')';
				}

				this.toXml = function()
				{
					var doc = Xml.createDocument('parameter');
					var root = doc.firstChild;
					Xml.setAttribute(root, 'type', this.parameterType);
					Xml.setAttribute(root, 'name', this.name);
					Xml.setAttribute(root, 'required', this.required ? 'true' : 'false');
					Xml.setAttribute(root, 'multiple', this.multiple ? 'true' : 'false');
					if (this.description) Xml.addTag(root, 'description', this.description);
					if (this.defaultValue) Xml.addTag(root, 'default', this.defaultValue);
					var optionsTag;
					for (var option in this.options)
					{
						if (!optionsTag) optionsTag = Xml.addTag(root, 'options');
						var optionTag = Xml.addTag(optionsTag, 'option', this.options[option]);
						Xml.setAttribute(optionTag, 'key', option);
					}
					return Xml.toString(doc);
				}

				this.validate = function(frm)
				{
					// A parameter name is required
					if (Main.trimString(this.name) == '')
					{
						return new ValidationError('Missing name for parameter', frm.parameterName);
					}
					// A parameter type is required
					else if (Main.trimString(this.parameterType) == '')
					{
						return new ValidationError('Missing type for parameter', frm.parameterType);
					}
					// The name must be unique
					for (var i = 0; i < allParameters.length; i++)
					{
						var other = allParameters[i];
						if (other == this) break;
						if (other.name == this.name)
						{
							return new ValidationError('Parameter has duplicate name: ' + this.name, 
									frm.parameterName);
						}
					}
					if (this.parameterType == 'enumeration')
					{
						// An enumeration must have at least one option
						var options = Main.trimString(this.getOption('enum'));
						if (options == '')
						{
							return new ValidationError('No options for enumeration: ' + this.name, 
									frm.enumerationOptions);
						}
						// If a default value is specified it must be among the options
						else if (this.defaultValue)
						{
							var opt = options.split(/[\n\r]/);
							var index = -1;
							for (var i = 0; i < opt.length; i++)
							{
								if (opt[i] == this.defaultValue)
								{
									index = i;
									break;
								}
							}
							if (index == -1)
							{
								return new ValidationError("'" + this.defaultValue + "' is not an option in enumeration: " + this.name, 
										frm.parameterDefault);
							}
						}
					}
					else if (this.parameterType == 'integer' || this.parameterType == 'float')
					{
						// If a default value is specified, it must be within max and min limits
						if (this.defaultValue)
						{
							var def = parseFloat(this.defaultValue);
							var min = parseFloat(this.getOption('min'));
							var max = parseFloat(this.getOption('max'));
							if (def < min)
							{
								return new ValidationError(def + ' < ' + min + ' for parameter: ' + this.name, 
										frm.parameterDefault);
							}
							else if (def > max)
							{
								return new ValidationError(def + ' > ' + max + ' for parameter: ' + this.name, 
										frm.parameterDefault);
							}
						}
					}
					return null;
				}
			}

			function ValidationError(msg, field)
			{
				this.msg = msg;
				this.field = field;
			}
			
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp" method="post" name="configure" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="parameter:externalParameters" value="">
		
		<h3 class="docked"><%=title%> <base:help helpid="executor.program.parameters" /></h3>
		<div class="boxed">
			<table class="form">
			<tr valign="baseline">
				<td class="prompt">Plugin</td>
				<td><%=plugin == null ? "<i>- none -</i>" : HTML.encodeTags(plugin.getName())%></td>
				<td class="prompt">Configuration</td>
				<td><%=pluginConfig == null ? "<i>- none -</i>" : HTML.encodeTags(pluginConfig.getName())%></td>
			</tr>
			</table>
			
			<div class="pluginhelp">
				<%=HTML.niceFormat(helpText)%>
			</div>
			
			<%
			if (errorMessage != null || (errors != null && errors.size() > 0))
			{
				%>
				<div id="errors" style="margin-bottom: 12px;" class="parameterhelp">
					<div class="error" style="margin: 0px;">
					<%=errorMessage %>
					</div>
					<%
					if (errors != null && errors.size() > 0)
					{
						%>
						<div id="showerrorlist" style="display: none;">
							<base:icon image="bullet.gif" /><a href="javascript:showErrorList()">Show</a>
						</div>
						<div id="errorlist">
							<ol>
							<%
							int i = 0;
							java.io.PrintWriter pw = new java.io.PrintWriter(out);
							for (Throwable t : errors)
							{
								++i;
								t.printStackTrace();
								%>
								<li><%=t.getMessage()%><br>
									<base:icon 
										image="show_section.gif" 
										onclick="<%="toggleStacktrace(" + i + ")"%>" 
										tooltip="Toggle display of detailed stacktrace"
										id="<%="stacktracelink." + i %>"
										style="float: left;"
									/>
									<div id="stacktrace.<%=i%>" style="display:none; font-size: smaller; position: relative; left: 1em; top: -1em; overflow: auto;">
									<%
									out.print("<pre>");
									while (t != null)
									{
										out.println(t.toString());
										StackTraceElement[] st = t.getStackTrace();
										for (int index = 0; index < st.length; ++index)
										{
											out.print("...at ");
											out.println(st[index].toString());
										}
										t = t.getCause();
										if (t != null) out.print("\nCaused by: ");
									}
									out.print("</pre>");
									%>
									</div>
								</li>
								<%
							}
							%>
							</ol>
							<base:icon image="bullet.gif" /><a href="javascript:hideErrorList()">Hide all</a>
						</div>
						<%
					}
					%>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0" border="0" cellpadding="0" width="100%">
			<tr>
			<td>			
				<table cellspacing="2" border="0" cellpadding="0" cellspacing="0">
				<tr valign="top">
				<td>
					<tbl:toolbar>
						<tbl:button 
							image="add.png" 
							title="Add" 
							onclick="addOnClick()"
							tooltip="Add a new parameter definition"
						/>
						<tbl:button 
							image="remove.png" 
							title="Remove" 
							onclick="removeOnClick()"
							tooltip="Remove the selected parameter(s)"
						/>
						<tbl:button 
							image="move_up.gif"
							onclick="moveParameter(false)" 
							tooltip="Move the selected paramer(s) up"
						/>
						<tbl:button 
							image="move_down.gif" 
							onclick="moveParameter(true)" 
							tooltip="Move the selected paramer(s) down"
						/>
					</tbl:toolbar>
					<select name="programParameters" size="18" style="width: 100%;" onclick="parameterOnClick()"></select>
				</td>
				</tr>
				</table>
			</td>
			<td>
				<table id="parameterDefinition" style="display: none;">
				<tr>
					<td class="prompt">Name</td>
					<td><input type="text" <%=requiredClazz%> name="parameterName" style="width:24em;" onchange="onFormChange()"></td>
				</tr>
				<tr>
					<td class="prompt">Parameter type</td>
					<td>
						<select name="parameterType" size="1" style="width:15em;" onClick="parameterTypeOnChange()" class="required">
							<option value="string" 
								title="A free-text string no more than 255 characters"
								>String (short)</option>
							<option value="text"
								title="A free-text string up to 64K characters"
								>String (long)</option>
							<option value="integer"
								title="An integer that is optionally bounded"
								>Integer</option>
							<option value="float"
								title="A floating point number"
								>Float</option>
							<option value="boolean"
								title="A true/false selection"
								>Boolean</option>
							<option value="enumeration"
								title="Select value(s) from a predefined list"
								>Enumeration</option>
							<option value="factor"
								title="Select experimental factor(s) to include in the export"
								>Experimental factor</option>
							<option value="spotformula"
								title="Select a spot formula to include in the export"
								>Spot field/formula</option>
							<option value="assays"
								title="Select special assays (all are still included in the export)"
								>Bioassay selection</option>
						</select>
						<br>
						<input type="checkbox" name="parameterIsRequired" value="1" onclick="onFormChange()">
						<b>Required</b>
						<input type="checkbox" name="parameterIsMultiple" value="1" onclick="onFormChange()">
						<b>Multiple values</b>
					</td>
				</tr>
				<tr id="minMax" style="display:none;">
					<td class="prompt">Min</td>
					<td>
						<input type="text" <%=clazz%> name="minValue" style="width:8em;" onchange="onFormChange()">
						<b>Max</b>
						<input type="text" <%=clazz%> name="maxValue" style="width:8em;" onchange="onFormChange()">
					</td>
				</tr>
				<tr id="enumerationOptions" style="display:none;">
					<td class="prompt">Options</td>
					<td>
						<textarea name="enumerationOptions" rows="5" style="width:24em;" 
							onchange="onFormChange()" title="One option per line"></textarea>
					</td>
				</tr>
				<tr id="regularDefault">
					<td class="prompt">Default value</td>
					<td><input type="text" <%=clazz%> name="parameterDefault" style="width:24em;" 
						onchange="onFormChange()" title="Enter a default values for the parameter"></td>
				</tr>
				<tr id="booleanDefault" style="display:none;">
					<td class="prompt">Default value</td>
					<td><input type="radio" name="booleanDefault" value="1" 
							onclick="onFormChange()"><a href="javascript:setRadio('booleanDefault', 0)">true</a>
						<input type="radio" name="booleanDefault" value="0" 
							onclick="onFormChange()"><a href="javascript:setRadio('booleanDefault', 1)">false</a>
					</td>
				</tr>
				<tr>
					<td class="prompt">Description</td>
					<td><textarea name="parameterDescription" rows="5" style="width:24em;" 
						onchange="onFormChange()" title="Enter a description/help text for this parameter"></textarea></td>
				</tr>
				<!--
				<tr>
					<td class="prompt">XML (debug)</td>
					<td><textarea name="parameterXML" rows="5" style="width:24em;"></textarea></td>
				</tr>
				-->
				</table>
								
						

				</td>		
				</tr>
			</table>
		</div>
		</form>
		<div align="center">
		<base:buttongroup>			
			<base:button onclick="saveSettings()" title="Next" />
			<base:button onclick="doCancel()" title="Cancel" />
		</base:buttongroup>
		</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null)
		dc.close();
}
%>
