<%-- $Id: edit_hybridization.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.Hybridization"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.LabeledExtract"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.HYBRIDIZATION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	String name = null;
	Hybridization hyb = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	ItemQuery<LabeledExtract> labeledExtractsQuery = null;
	
	boolean readCurrentArraySlide = true;
	ArraySlide currentArraySlide = null;
	
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	Protocol defaultProtocol = null;
	
	boolean readCurrentHybStation = true;
	Hardware currentHybStation = null;
	Hardware defaultHybStation = null;

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<Hardware> recentStations = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE);
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultProtocol = (Protocol)activeProject.getDefaultItem(dc, Project.Default.HYBRIDIZATION_PROTOCOL);
		}
		catch (PermissionDeniedException pdex)
		{
			defaultProtocol = null;
		}
		try
		{
			defaultHybStation = (Hardware)activeProject.getDefaultItem(dc, Project.Default.HYBRIDIZATION_HARDWARE);
		}
		catch (PermissionDeniedException pdex)
		{
			defaultHybStation = null;
		}
	}
	if (itemId == 0)
	{
		title = "Create hybridization";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		if (cc.getPropertyFilter("creationEvent.hardware.name") != null)
		{
			currentHybStation = Base.getFirstMatching(dc, Hardware.getQuery(), "name", cc.getPropertyFilter("creationEvent.hardware.name"));
		}
		if (cc.getPropertyFilter("arraySlide.name") != null)
		{
			currentArraySlide = Base.getFirstMatching(dc, ArraySlide.getQuery(), "name", cc.getPropertyFilter("arraySlide.name"));
		}
		name = Values.getString(cc.getPropertyValue("name"), "New hybridization");
		eventDate = (Date)cc.getPropertyObject("creationEvent.eventDate");
		
		if (Values.getBoolean(request.getParameter("useParents")))
		{
			ItemContext lc = sc.getCurrentContext(Item.LABELEDEXTRACT);
			if (lc.getSelected().size() > 0)
			{
				labeledExtractsQuery = LabeledExtract.getQuery();
				labeledExtractsQuery.include(Include.ALL);
				labeledExtractsQuery.order(Orders.asc(Hql.property("name")));
				labeledExtractsQuery.restrict(Restrictions.in(Hql.property("id"), 
					Expressions.parameter("selected", lc.getSelected(), Type.INT)));
			}
		}
		else if (request.getParameter("labeledextract_id") != null)
		{
			int leId = Values.getInt(request.getParameter("labeledextract_id"));
			labeledExtractsQuery = LabeledExtract.getQuery();
			labeledExtractsQuery.include(Include.ALL);
			labeledExtractsQuery.restrict(Restrictions.eq(Hql.property("id"), 
				Expressions.integer(leId)));
		}
	}
	else
	{
		hyb = Hybridization.getById(dc, itemId);
		creationEvent = hyb.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		cc.setObject("item", hyb);
		title = "Edit hybridization -- " + HTML.encodeTags(hyb.getName());
		name = hyb.getName();
		try
		{
			currentArraySlide = hyb.getArraySlide();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArraySlide = false;
		}
		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentHybStation = creationEvent.getHardware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHybStation = false;
		}
		
		// Query to retrieve source labeled extracts
		labeledExtractsQuery = (ItemQuery<LabeledExtract>)creationEvent.getSources();
		labeledExtractsQuery.include(Include.ALL);
		labeledExtractsQuery.order(Orders.asc(Hql.property("name")));
		
	}
	if (hyb != null) hyb.checkPermission(Permission.WRITE);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,linkitems.js,ajax.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Hybridization" tab
		function validateHybridization()
		{
			var frm = document.forms['hybridization'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (!Numbers.isInteger(frm.numArrays.value))
			{
				alert("'" + frm.numArrays.value + "' is not a valid number");
				frm.numArrays.focus();
				return false;
			}
			else if (parseInt(frm.numArrays.value) <= 0)
			{
				alert("Number of arrays must be > 0");
				frm.numArrays.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['hybridization'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.modifiedLabeledExtracts.value = Link.exportModified(frm, 'L', true).join(',');
				frm.removedLabeledExtracts.value = Link.getActionIds(-1, 'L').join(',');
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=hyb == null ? 0 : hyb.getId()%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['hybridization'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}

		function getParents()
		{
			var frm = document.forms['hybridization'];
			var parents = new Array();

			var arraySlideId = Math.abs(parseInt(frm.arrayslide_id[frm.arrayslide_id.selectedIndex].value));
			if (arraySlideId > 0) parents[parents.length] = 'ARRAYSLIDE:'+arraySlideId;

			var ids = Link.getListIds(frm.labeled_extracts, 'L');
			if (ids.length > 0)
			{
				parents[parents.length] = 'LABELEDEXTRACT:'+ids.join(':');
			}
			return parents;
		}

		function selectProtocolOnClick()
		{
			var frm = document.forms['hybridization'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&filter:INT:protocolType=<%=SystemItems.getId(ProtocolType.HYBRIDIZATION)%>';
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['hybridization'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}
		
		function selectHybStationOnClick()
		{
			var frm = document.forms['hybridization'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setHybStationCallback';
			if (frm.hardware_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&filter:INT:hardwareType=<%=SystemItems.getId(HardwareType.HYBRIDIZATION_STATION)%>';
			Main.openPopup(url, 'SelectHybStation', 1000, 700);
		}
		function setHybStationCallback(id, name)
		{
			var frm = document.forms['hybridization'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function arraySlideOnChange()
		{
			var frm = document.forms['hybridization'];
			var selectedIndex = frm.arrayslide_id.selectedIndex
			var arraySlideId = frm.arrayslide_id[selectedIndex].value;
			if (arraySlideId > 0) updateNumArrays(arraySlideId);
			parentsChanged = true;
		}
		function selectArraySlideOnClick()
		{
			var frm = document.forms['hybridization'];
			var url = '../../lims/arrayslides/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setArraySlideCallback';
			if (frm.arrayslide_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.arrayslide_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&filter:STRING:hybridization.name==';
			url += '&filter:BOOLEAN:destroyed=false';
			Main.openPopup(url, 'SelectArraySlide', 1000, 700);
		}
		function setArraySlideCallback(arraySlideId, name)
		{
			var frm = document.forms['hybridization'];
			if (frm.arrayslide_id.length < 2) // >
			{
				frm.arrayslide_id[frm.arrayslide_id.length] = new Option();
			}
			frm.arrayslide_id[1].value = arraySlideId;
			frm.arrayslide_id[1].text = name;
			frm.arrayslide_id.selectedIndex = 1;
			updateNumArrays(arraySlideId);
			parentsChanged = true;
		}
		function updateNumArrays(arraySlideId)
		{
			var request = Ajax.getXmlHttpRequest();
			if (request != null)
			{
				var url = '../../lims/arrayslides/ajax.jsp?ID=<%=ID%>&cmd=GetNumArrays&item_id=' + arraySlideId;
				request.open("GET", url, true);
				Ajax.setReadyStateHandler(request, updateNumArraysCallback);
				request.send(null);
			}
			return request != null;
		}
		function updateNumArraysCallback(request)
		{
			var frm = document.forms['hybridization'];
			var numArrays = Main.trimString(request.responseText);
			if (numArrays)
			{
				frm.numArrays.value = numArrays;
			}
		}
		
		function addLabeledExtractsOnClick()
		{
			var frm = document.forms['hybridization'];
			var ids = Link.getListIds(frm.labeled_extracts, 'L');
			var excludes = ids.join(',');
			
			var url = '../../biomaterials/labeledextracts/index.jsp?ID=<%=ID%>&mode=selectmultiple&callback=addLabeledExtractCallback';
			url += '&exclude='+excludes;
			Main.openPopup(url, 'AddLabeledExtracts', 1000, 700);
		}
		function addLabeledExtractCallback(labeledExtractId, name)
		{
			var item = Link.getItem('L', labeledExtractId);
			if (!item) item = new Item('L', labeledExtractId, '1: '+name+' [-]', '', '');
			Link.addItem(document.forms['hybridization'].labeled_extracts, item);
			parentsChanged = true;
			labeledExtractsOnChange();
		}
		function labeledExtractsOnChange()
		{
			var frm = document.forms['hybridization'];
			var item = frm.labeled_extracts[frm.labeled_extracts.selectedIndex].item;
			if (item && item.id)
			{
				var i = item.value ? item.value.indexOf(':') : -1;
				frm.used_quantity.value = i >= 0 ? item.value.substring(0, i) : item.value;
				frm.array_index.value = i > 0 ? item.value.substring(i+1) : '1';
				frm.used_quantity.focus();
			}
			else
			{
				frm.used_quantity.value = '';
				frm.array_index.value = '1';
			}
		}
		function usedQuantityOnBlur()
		{
			var frm = document.forms['hybridization'];
			var usedQuantity = frm.used_quantity.value;
			var arrayIndex = frm.array_index.value;
			var numArrays = parseInt(frm.numArrays.value);
			if (arrayIndex != '' && (arrayIndex > numArrays || arrayIndex <= 0))
			{
				alert('Array index must be between 1 and ' + numArrays);
				return;
			}
			if (arrayIndex == '') arrayIndex = 1;
			var displayQuantity = usedQuantity == '' ? '-' : usedQuantity+' µg';
			for (var i = 0; i < frm.labeled_extracts.length; i++)	// >
			{
				var option = frm.labeled_extracts[i];
				if (option.selected && option.item.id)
				{
					option.item.value = usedQuantity + ':' + arrayIndex;
					var text = option.text.replace(/\[.*\]/, '['+displayQuantity+']');
					text = text.replace(/\d*\:/, arrayIndex + ':');
					option.text = text; 
				}
			}
		}
		function arrayIndexOnBlur()
		{
			usedQuantityOnBlur();
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['hybridization'].labeled_extracts);
			parentsChanged = true;
		}

		
		function init()
		{
			var frm = document.forms['hybridization'];
			var labeledExtracts = frm.labeled_extracts;
			<%
			if (hyb == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			if (labeledExtractsQuery != null)
			{
				ItemResultList<LabeledExtract> labeledExtracts = labeledExtractsQuery.list(dc);
				for (LabeledExtract le : labeledExtracts)
				{
					if (hyb == null)
					{
						%>
						Link.addItem(labeledExtracts, new Item('L', <%=le.getId()%>, '1: <%=HTML.javaScriptEncode(le.getName())%> [-]', ':1'));
						<%
					}
					else
					{
						Float used = creationEvent.getUsedQuantity(le);
						String usedQuantity = Values.formatNumber(used, -1);
						String usedWithUnit = used == null ? "-" : usedQuantity + " µg";
						int arrayIndex = creationEvent.getSourceGroup(le);
						%>
						Link.addNewItem(labeledExtracts, new Item('L', <%=le.getId()%>, '<%=arrayIndex + ": " + HTML.javaScriptEncode(le.getName())%> [<%=usedWithUnit%>]', '<%=usedQuantity%>:<%=arrayIndex%>'));
						<%
					}
				}
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="hybridization" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=hyb != null%>" switch="switchTab">
		<t:tab id="info" title="Hybridization" validate="validateHybridization()" helpid="hybridization.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=name%>" 
					size="40" maxlength="<%=Hybridization.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Arrays</td>
				<td><input <%=requiredClazz%> type="text" name="numArrays" 
					value="<%=hyb == null ? Values.getString(cc.getPropertyValue("numArrays"), "1") : hyb.getNumArrays()%>" 
					size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">Created</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="event_date" 
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Created', 'hybridization', 'event_date', null, '"+jsDateFormat+"')"%>"
						image="calendar.png"
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitem="<%=defaultProtocol%>"
						newitem="<%=hyb == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Hardware</td>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHybStation%>"
						denied="<%=!readCurrentHybStation%>"
						recent="<%=recentStations%>"
						defaultitem="<%=defaultHybStation%>"
						newitem="<%=hyb == null%>"
						onselect="selectHybStationOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Array slide</td>
				<td>
					<base:select 
						id="arrayslide_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentArraySlide%>"
						denied="<%=!readCurrentArraySlide%>"
						newitem="<%=hyb == null%>"
						onselect="selectArraySlideOnClick()"
						onchange="arraySlideOnChange()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(hyb == null ? cc.getPropertyValue("description") : hyb.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'hybridization', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="labeledExtracts" title="Labeled extracts" helpid="hybridization.labeledextracts">
			<input type="hidden" name="modifiedLabeledExtracts" value="">
			<input type="hidden" name="removedLabeledExtracts" value="">
		
			<table class="form" cellspacing=0>
			<tr valign="top">
				<td class="prompt">Labeled extracts</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="labeled_extracts" size="5" multiple style="width: 20em;" 
							onchange="labeledExtractsOnChange()">
						</select>&nbsp;<br>
					</td>
					<td>
						<table border="0">
						<tr><td width="150"><base:button 
							onclick="addLabeledExtractsOnClick()" 
							title="Add&nbsp;labeled&nbsp;extracts&hellip;" 
							tooltip="Add labeled extracts"
							/></td></tr>
						<tr><td width="150"><base:button 
							onclick="removeOnClick()" 
							title="Remove" 
							tooltip="Remove the selected labeled extracts"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			
			<tr>
				<td style="text-align: right; padding-right: 5px;">- used quantity</td>
				<td>
						<input <%=clazz%> type="text" name="used_quantity" value=""
							size="12" maxlength="10" onkeypress="return Numbers.numberOnly(event)"
							onkeyup="usedQuantityOnBlur()"
						> (µg)
				</td>
			</tr>

			<tr>
				<td style="text-align: right; padding-right: 5px;">- array index</td>
				<td>
						<input <%=clazz%> type="text" name="array_index" value=""
							size="12" maxlength="10" onkeypress="return Numbers.numberOnly(event)"
							onkeyup="arrayIndexOnBlur()"
						>
				</td>
			</tr>

			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
