<%-- $Id: index.jsp 5297 2010-03-31 11:26:32Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.ReporterScoreQuery"
	import="net.sf.basedb.core.DataQuery"
	import="net.sf.basedb.core.DataResultIterator"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("score", "name,score,externalId,symbol,description");
	private static final Item itemType = Item.REPORTERSCORE;
	static
	{
		defaultContext.setSortDirection(ItemContext.SortDirection.DESC);
	}
%>
<%
final int reporterListId = Values.getInt(request.getParameter("reporterlist_id"));

final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_reporters.jsp?ID="+ID
	+"&reporterlist_id="+reporterListId
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_reporter.jsp?ID="+ID+"&reporterlist_id="+reporterListId;
final String editPage = "edit_reporter.jsp?ID="+ID+"&reporterlist_id="+reporterListId;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;
try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}
	
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		ReporterList reporterList = ReporterList.getById(dc, reporterListId);
		for (int reporterId : cc.getSelected())
		{
			reporterList.removeReporter(Reporter.getById(dc, reporterId));
		}
		dc.commit();
		redirect = listPage;
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		dc = sc.newDbControl();
		ReporterList reporterList = ReporterList.getById(dc, reporterListId);
		final ReporterScoreQuery query = reporterList.getReporterScores();
		query.join(Hql.innerJoin(null, "reporter", "rpt", true));
		dc.close();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+reporters";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		dc = sc.newDbControl();
		ReporterList reporterList = ReporterList.getById(dc, reporterListId);
		final ReporterScoreQuery query = reporterList.getReporterScores();
		query.join(Hql.innerJoin(null, "reporter", "rpt", true));
		dc.close();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		// Set file type filter
		ItemContext fileContext = sc.getCurrentContext(Item.FILE);
		fileContext.setPropertyFilter(FileType.getPropertyFilter(FileType.REPORTER));
		redirect = "../../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+reporters";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		dc = sc.newDbControl();
		ReporterList reporterList = ReporterList.getById(dc, reporterListId);
		final ReporterScoreQuery query = reporterList.getReporterScores();
		query.join(Hql.innerJoin(null, "reporter", "rpt", true));
		dc.close();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("AddReporters".equals(cmd))
	{
		dc = sc.newDbControl();
		ReporterList reporterList = ReporterList.getById(dc, reporterListId);
		ItemContext reporterContext = sc.getCurrentContext(Item.REPORTER);
		final DataQuery<ReporterData> query = Reporter.getQuery();
		reporterContext.configureQuery(query, true);
		String which = request.getParameter("which");
		if ("selected".equals(which))
		{
			query.setFirstResult(0);
			query.setMaxResults(-1);
			Integer[] itemIds = Values.getInt(request.getParameter("items").split(","));
			query.restrict(
				Restrictions.in(
					Hql.property("id"),
					Expressions.parameter("_selected_")
				)
			);
			query.setParameter("_selected_", Arrays.asList(itemIds), Type.INT);			
		}
		else if ("all".equals(which))
		{
			query.setFirstResult(0);
			query.setMaxResults(-1);
		}
		DataResultIterator<ReporterData> result = query.iterate(dc);
		int count = 0;
		while (result.hasNext())
		{
			if (reporterList.addReporter(result.next(), null)) count++;
		}
		dc.commit();
		message = count + " reporters added";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

