<%-- $Id: list_reporters.jsp 5297 2010-03-31 11:26:32Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/
	
	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.
	
	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ReporterList"
	import="net.sf.basedb.core.ReporterType"
	import="net.sf.basedb.core.ReporterScore"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.ReporterScoreQuery"
	import="net.sf.basedb.core.ReporterScoreResultIterator"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.REPORTERSCORE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int reporterListId = Values.getInt(request.getParameter("reporterlist_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();

final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("reporter", "reporters");
final DbControl dc = sc.newDbControl();
ReporterScoreResultIterator reporters = null;
ItemResultList<ReporterType> reporterTypes = null;
try
{
	final ReporterList reporterList = ReporterList.getById(dc, reporterListId);
	final boolean createPermission = reporterList.hasPermission(Permission.WRITE);
	final boolean writePermission = createPermission;
	final boolean deletePermission = createPermission;

	final ReporterScoreQuery query = reporterList.getReporterScores();
	query.join(Hql.innerJoin(null, "reporter", "rpt", true));
	final ItemQuery<ReporterType> typeQuery = ReporterType.getQuery();
	typeQuery.order(Orders.asc(Hql.property("name")));
	typeQuery.setCacheResult(true);
	List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	try
	{
		cc.configureQuery(dc, query, true);
		reporters = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, reporterList);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'reporters';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function addItems()
		{
			Main.openPopup('add_reporters_frameset.jsp?ID=<%=ID%>&reporterlist_id=<%=reporterListId%>', 'AddReporters', 1000, 700);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			var numChecked = Forms.numChecked(frm);
			if (numChecked == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			else
			{
				var rep = numChecked == 1 ? 'reporter' : 'reporters';
				if (!confirm('You are about to delete '+numChecked+' '+rep+' from the reporter list. This can\'t be undone. Continue?'))
				{
					return;
				}
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 740, 540);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties')
			{
				location.href = '../index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=reporterListId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	
	<base:body>
	<p>
		<p:path>
			<p:pathelement title="Reporter lists" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(reporterList.getName())%>" />
		</p:path>
	
		<t:tabcontrol id="main" active="reporters" switch="switchTab">
		<t:tab id="properties" title="Properties" />
		
		<t:tab id="reporters" title="Reporters">

		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="reporters" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:hidden 
				name="reporterlist_id" 
				value="<%=String.valueOf(reporterListId)%>" 
			/>
			<tbl:columndef 
				id="externalId"
				clazz="uniquecol"
				property="reporter.externalId"
				datatype="string"
				title="External ID"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="name"
				property="reporter.name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="reporter.id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="score"
				property="score"
				datatype="float"
				title="Score"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="symbol"
				property="reporter.symbol"
				datatype="string"
				title="Gene symbol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="reporter.description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef
				id="reporterList"
				property="$rpt.reporterListScores"
				datatype="int"
				title="Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>
			<tbl:columndef 
				id="entryDate"
				property="reporter.entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="lastUpdate"
				property="reporter.lastUpdate"
				datatype="date"
				title="Last update" 
				sortable="true" 
				filterable="true" 
				exportable="true"
				formatter="<%=dateTimeFormatter%>"
			/>
			<%
			if (reporterProperties != null)
			{
				for (ExtendedProperty ep : reporterProperties)
				{
					String name = ep.getName();
					%>
					<tbl:columndef
						id="<%=name%>"
						property="<%="reporter."+name%>"
						datatype="<%=ep.getType().getStringValue()%>"
						title="<%=HTML.encodeTags(ep.getTitle())%>"
						sortable="true"
						filterable="true"
						exportable="true"
						formatter="<%=FormatterFactory.getExtendedPropertyFormatter(sc, ep)%>"
					/>
					<%
				}
			}
			Enumeration<String, String> types = new Enumeration<String, String>();
			reporterTypes = typeQuery.list(dc);
			types.add("", "- none -");
			for (ReporterType rt : reporterTypes)
			{
				types.add(Integer.toString(rt.getId()), HTML.encodeTags(rt.getName()));
			}
			%>
			<tbl:columndef 
				id="reporterType"
				property="reporter.reporterType"
				sortproperty="reporter.reporterType.name"
				exportproperty="reporter.reporterType.name"
				datatype="int"
				enumeration="<%=types%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					disabled="<%=writePermission ? false : true%>" 
					image="<%=writePermission ? "add.png" : "add_disabled.png"%>" 
					onclick="addItems()" 
					title="Add&hellip;" 
					tooltip="<%=writePermission ? "Add reporters to this list" : "You do not have permission to add reporters" %>" 
				/>
				<tbl:button 
					disabled="<%=deletePermission ? false : true%>" 
					image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
					onclick="deleteItems()" 
					title="Remove&hellip;" 
					tooltip="<%=deletePermission ? "Remove the selected items from this list" : "You do not have permission to remove reporters" %>" 
				/>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=reporters == null ? 0 : reporters.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (reporters != null)
					{						
						while (reporters.hasNext())
						{
							ReporterScore score = reporters.next();
							ReporterData item = score.getReporter();
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ?
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="externalId"><%=HTML.encodeTags(item.getExternalId())%></tbl:cell>
								<tbl:cell column="score"><%=Values.formatNumber(score.getScore(), 2)%></tbl:cell>
								<tbl:cell column="symbol"><%=HTML.encodeTags(item.getSymbol())%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="lastUpdate" value="<%=item.getLastUpdate()%>" />
								<tbl:cell column="reporterType"><base:propertyvalue dbcontrol="<%=dc%>" item="<%=item%>" property="reporterType.name" /></tbl:cell>
								<%
								if (reporterProperties != null)
								{
									for (ExtendedProperty ep : reporterProperties)
									{
										name = ep.getName();
										%>
										<tbl:cell column="<%=name%>"><tbl:cellvalue value="<%=item.getExtended(name)%>" /></tbl:cell>
										<%
									}
								}
								%>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=reporters == null || reporters.getTotalCount() == 0 ? "No reporters were found" : "No reporters on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=reporters == null ? 0 : reporters.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center" clazz="fixedatbottom">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>

		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (reporters != null) reporters.close();
	if (dc != null) dc.close();
}
%>
